Index: channel.c
===================================================================
--- channel.c	(revision 40987)
+++ channel.c	(working copy)
@@ -2891,7 +2891,7 @@
 
 	AST_LIST_TRAVERSE_SAFE_BEGIN(&original->varshead, varptr, entries) {
 		if (!strncmp(ast_var_name(varptr), GROUP_CATEGORY_PREFIX, strlen(GROUP_CATEGORY_PREFIX))) {
-			AST_LIST_REMOVE(&original->varshead, varptr, entries);
+			AST_LIST_REMOVE_CURRENT(&original->varshead, entries);
 			ast_var_delete(varptr);
 		}
 	}
@@ -2900,7 +2900,7 @@
 	/* Append variables from clone channel into original channel */
 	/* XXX Is this always correct?  We have to in order to keep MACROS working XXX */
 	if (AST_LIST_FIRST(&clone->varshead))
-		AST_LIST_INSERT_TAIL(&original->varshead, AST_LIST_FIRST(&clone->varshead), entries);
+		AST_LIST_APPEND_LIST(&original->varshead, &clone->varshead, entries);
 }
 
 /*--- ast_do_masquerade: Masquerade a channel */
